#!/bin/zsh

cgi_post

card="$_POST[\"card\"]"
tempfile="temp/$card"
cardfile="vcard/$card"

echo "BEGIN:VCARD\r" >"$tempfile"
echo "VERSION:4.0\r" >>"$tempfile"
echo "N:$_POST[\"0N\"];$_POST[\"1N\"];$_POST[\"2N\"];$_POST[\"3N\"];$_POST[\"4N\"]\r" >>"$tempfile"
echo "UID:$_POST[\"UID\"]\r" >>"$tempfile"
for field in $VCF_FIELDS; do
  value="$_POST[\"$field\"]"
  n=0
  while [ -n "$value" ]; do
    echo "${field}:${value}\r"
    value="$_POST[\"$field$n\"]"
    n=$(($n + 1))
  done
done >>"$tempfile"

case "$_POST[\"action\"]" in
  addfield)
    echo "$_POST[\"newfield\"]:\r" >>"$tempfile"
    echo "END:VCARD\r" >>"$tempfile"
    echo -n "Location: http://$HTTP_HOST/?page=attendees&edit=$card\n\n"
    ;;
  update)
    echo "END:VCARD\r" >>"$tempfile"
    mv "$tempfile" "$cardfile"
    echo -n "Location: http://$HTTP_HOST/?page=attendees#$card\n\n"
    ;;
  cancel)
    rm "$tempfile"
    [ -f "$cardfile" ] \
      && echo -n "Location: http://$HTTP_HOST/?page=attendees#$card\n\n" \
      || echo -n "Location: http://$HTTP_HOST/?page=attendees\n\n"
    ;;
  delete)
    rm "$tempfile" "$cardfile"
    echo -n "Location: http://$HTTP_HOST/?page=attendees\n\n"
    ;;
esac
